using System;
using System.Windows.Forms;
using System.Drawing;
using System.Runtime.InteropServices;
using ComTypes = System.Runtime.InteropServices.ComTypes;
using System.Reflection;

namespace ADX_Drag_Drop_Minimized_CS
{
	/// <summary>
	/// Summary description for ADXOlForm1.
	/// </summary>
	public class ADXOlForm1 : AddinExpress.OL.ADXOlForm
	{
		private Panel panel1;
		private Label label1;
		private Panel panel2;
		private TextBox textBoxDragTarget;
		private System.ComponentModel.IContainer components = null;

		public ADXOlForm1()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel1 = new System.Windows.Forms.Panel();
			this.label1 = new System.Windows.Forms.Label();
			this.panel2 = new System.Windows.Forms.Panel();
			this.textBoxDragTarget = new System.Windows.Forms.TextBox();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.label1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(300, 27);
			this.panel1.TabIndex = 2;
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(12, 9);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(144, 13);
			this.label1.TabIndex = 2;
			this.label1.Text = "The target for Drag and Drop";
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.textBoxDragTarget);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 27);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(300, 311);
			this.panel2.TabIndex = 3;
			// 
			// textBoxDragTarget
			// 
			this.textBoxDragTarget.AllowDrop = true;
			this.textBoxDragTarget.Dock = System.Windows.Forms.DockStyle.Fill;
			this.textBoxDragTarget.Location = new System.Drawing.Point(0, 0);
			this.textBoxDragTarget.Multiline = true;
			this.textBoxDragTarget.Name = "textBoxDragTarget";
			this.textBoxDragTarget.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBoxDragTarget.Size = new System.Drawing.Size(300, 311);
			this.textBoxDragTarget.TabIndex = 1;
			this.textBoxDragTarget.DragDrop += new System.Windows.Forms.DragEventHandler(this.textBoxDragTarget_DragDrop);
			this.textBoxDragTarget.DragOver += new System.Windows.Forms.DragEventHandler(this.textBoxDragTarget_DragOver);
			// 
			// ADXOlForm1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(300, 338);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.panel1);
			this.Name = "ADXOlForm1";
			this.Text = "ADXOlForm1";
			this.ADXDragOverMinimized += new AddinExpress.OL.ADXOlForm.DragOverMinimized_EventHandler(this.ADXOlForm1_ADXDragOverMinimized);
			this.panel1.ResumeLayout(false);
			this.panel1.PerformLayout();
			this.panel2.ResumeLayout(false);
			this.panel2.PerformLayout();
			this.ResumeLayout(false);

		}
		#endregion

		private void ADXOlForm1_ADXDragOverMinimized(object sender, ADXDragOverMinimizedEventArgs e)
		{
			e.Expand = false;
			if (DoFormats(e, "RenPrivateItem"))
			{
				if (DoDragOver(e))
					e.Expand = true;
			}
			else
			{
				if (DoFormats(e, "Text"))
					e.Expand = true;
			}
		}

		private void textBoxDragTarget_DragOver(object sender, DragEventArgs e)
		{
			e.Effect = DragDropEffects.None;
			if (DoFormats(e, "RenPrivateItem"))
			{
				if (DoDragOver(e))
					e.Effect = DragDropEffects.All;
			}	
			else
			{
				if (DoFormats(e, "Text"))
					e.Effect = DragDropEffects.All;
			}
		}

		private void textBoxDragTarget_DragDrop(object sender, DragEventArgs e)
		{
			if (DoFormats(e, "RenPrivateItem"))
			{
				Outlook.Selection selection = (ExplorerObj as Outlook._Explorer).Selection;
				if (selection != null)
					try
					{
						Outlook._MailItem mailItem = selection.Item(1) as Outlook._MailItem;
						if (mailItem != null)
							try
							{
								textBoxDragTarget.Clear();
								textBoxDragTarget.Text = mailItem.Body;
							}
							finally { Marshal.ReleaseComObject(mailItem); }
					}
					finally { Marshal.ReleaseComObject(selection); }
			}
			else
			{
				if (DoFormats(e, "Text"))
				{
					textBoxDragTarget.Clear();
					textBoxDragTarget.Text = e.Data.GetData(DataFormats.StringFormat).ToString();
				}
			}
		}

		private bool DoFormats(System.Windows.Forms.DragEventArgs e, string strFormat)
		{
			string[] stringFormats = e.Data.GetFormats();
			foreach (string str in stringFormats)
			{
				if (str == strFormat)
					return true;
			}
			return false;
		}

		private bool DoDragOver(object e)
		{
			Outlook.Selection selection = (ExplorerObj as Outlook._Explorer).Selection;
			if (selection != null)
				try
				{
					if (selection.Count == 1)
					{
						Outlook._MailItem mailItem = selection.Item(1) as Outlook._MailItem;
						if (mailItem != null)
							try
							{
								return true;
								//if ((e as ADXDragOverMinimizedEventArgs) != null)
								//    (e as ADXDragOverMinimizedEventArgs).Expand = true;
								//(e as DragEventArgs).Effect = DragDropEffects.All;
							}
							finally { Marshal.ReleaseComObject(mailItem); }
					}
				}
				finally { Marshal.ReleaseComObject(selection); }
			return false;
		}
	}
}